## libmbd 0.12.7

=== tests/CMakeLists.txt ===
add_executable(mbd_grad_tests mbd_grad_tests.F90 mbd_grad_test_cases.F90)
add_executable(mbd_api_tests mbd_api_tests.F90)
foreach(TEST_APP mbd_grad_tests mbd_api_tests)
    target_include_directories(${TEST_APP} PRIVATE $<TARGET_FILE_DIR:mbd>)
    target_link_libraries(${TEST_APP} PRIVATE mbd)
    if(ENABLE_SCALAPACK_MPI)
        target_link_libraries(${TEST_APP} PRIVATE MPI::MPI_Fortran)
        set_property(TARGET ${TEST_APP} APPEND PROPERTY COMPILE_DEFINITIONS WITH_MPI WITH_SCALAPACK)
    endif()
    if(ENABLE_ELSI)
        set_property(TARGET ${TEST_APP} APPEND PROPERTY COMPILE_DEFINITIONS WITH_ELSI)
    endif()
endforeach()

execute_process(
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/collect-mbd-tests.py
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE TESTS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(ENABLE_SCALAPACK_MPI)
    set(MPI_NODES $ENV{MPI_NODES})
    if(NOT "${MPI_NODES}")
        set(MPI_NODES ${MPIEXEC_MAX_NUMPROCS})
    endif()
    set(MPIEXEC_EXTRA_FLAGS $ENV{MPIEXEC_EXTRA_FLAGS})
endif()
foreach(TEST ${TESTS})
    string(REPLACE "/" ";" TEST_APP_CASE ${TEST})
    list(GET TEST_APP_CASE 0 TEST_APP)
    list(GET TEST_APP_CASE 1 TEST_CASE)
    add_test(NAME "${TEST_APP}/${TEST_CASE}" COMMAND
        ${MPIEXEC_EXECUTABLE}
        ${MPIEXEC_EXTRA_FLAGS}
        ${MPIEXEC_NUMPROC_FLAG}
        ${MPI_NODES}
        ${MPIEXEC_PREFLAGS}
        $<TARGET_FILE:mbd_${TEST_APP}_tests>
        ${TEST_CASE}
        ${MPIEXEC_POSTFLAGS}
    )
endforeach()

=== debian/changelog ===
libmbd (0.12.7-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Sun, 15 Oct 2023 11:06:33 +0200

=== debian/control ===
Source: libmbd
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               dh-python,
               gfortran,
               libblas-dev,
               liblapack-dev,
               mpi-default-dev,
               python3
Standards-Version: 4.5.1
Homepage: https://github.com/libmbd/libmbd
Vcs-Browser: https://salsa.debian.org/debichem-team/libmbd
Vcs-Git: https://salsa.debian.org/debichem-team/libmbd.git

Package: libmbd-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Many-body dispersion library (development files)
 libMBD implements the many-body dispersion (MBD) method.
 .
 This package contains the static libraries and the header files.

## libmbd 0.12.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
cmake_policy(SET CMP0042 NEW)
cmake_policy(SET CMP0077 NEW)

set(CMAKE_USER_MAKE_RULES_OVERRIDE_Fortran
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/fortran_flags_override.cmake")

project(libMBD
    DESCRIPTION "Many-body dispersion library"
    LANGUAGES Fortran C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(libMBDVersion)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(CTest)

option(ENABLE_SCALAPACK_MPI "Enable parallelisation with ScaLAPACK/MPI")
CMAKE_DEPENDENT_OPTION(ENABLE_ELSI "Enable ELSI interface" OFF ENABLE_SCALAPACK_MPI OFF)
option(ENABLE_C_API "Enable C API" ON)

option(BUILD_SHARED_LIBS "Build shared rather than static library" ON)

set(DEFAULT_BUILD_TYPE "Release")
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
    set(DEFAULT_BUILD_TYPE "Debug")
endif()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to ${DEFAULT_BUILD_TYPE} as none was set")
    set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}")
endif()

if(NOT TARGET LAPACK::LAPACK)
    find_package(LAPACK REQUIRED)
    if(CMAKE_VERSION VERSION_LESS 3.18)
        add_library(LAPACK::LAPACK INTERFACE IMPORTED)
        target_link_libraries(LAPACK::LAPACK INTERFACE ${LAPACK_LINKER_FLAGS} ${LAPACK_LIBRARIES})
    endif()
endif()

if(ENABLE_SCALAPACK_MPI)
    if(NOT TARGET MPI::MPI_Fortran)
        find_package(MPI REQUIRED)
        if(APPLE)
            # -flat_namespace (Darwin-specific) is causing a crash (seg fault) when the
            # Fortran library is called from Python and one writes into a character
            # variable, but only when the kind is the default one. It causes the
            # written to variable to appear as being four times shorter than it is.
            # Only mention of anything possibly related I could find is at
            #
            #   https://trac.mpich.org/projects/mpich/ticket/1590
            get_target_property(_VALUE MPI::MPI_Fortran INTERFACE_LINK_OPTIONS)
            string(REGEX REPLACE "-Wl\\$<COMMA>-flat_namespace ?" "" _VALUE "${_VALUE}")
            set_target_properties(MPI::MPI_Fortran PROPERTIES INTERFACE_LINK_OPTIONS "${_VALUE}")
        endif()
    endif()
    if(MPI_Fortran_HAVE_F08_MODULE)
        message(STATUS "Will use the mpi_f08 Fortran module")
    endif()
    if(NOT TARGET scalapack AND NOT DEFINED SCALAPACK_LIBRARY)
        find_package(scalapack QUIET)
        if(scalapack_FOUND)
            message(STATUS "ScaLAPACK CMake package found in ${scalapack_DIR}")
        else()
            find_package(PkgConfig)
            if(PkgConfig_FOUND)
                unset(scalapack_FOUND CACHE)
                pkg_search_module(scalapack scalapack scalapack-openmpi)
                if(scalapack_FOUND)
                    message(STATUS "ScaLAPACK pkg-config package found, version ${scalapack_VERSION}")
                    set(SCALAPACK_LIBRARY "${scalapack_LDFLAGS}")
                endif()
            endif()
        endif()
        if(NOT scalapack_FOUND)
            message(SEND_ERROR "ScaLAPACK Cmake or pkg-config package not found, \
specify custom installation with SCALAPACK_LIBRARY")
        endif()
    endif()
    if(NOT TARGET scalapack AND DEFINED SCALAPACK_LIBRARY)
        add_library(scalapack INTERFACE IMPORTED)
        target_link_libraries(scalapack INTERFACE "${SCALAPACK_LIBRARY}")
    endif()
endif()

if(ENABLE_ELSI AND NOT TARGET elsi::elsi)
    find_package(elsi 2.0 QUIET)
    if(elsi_FOUND)
        message(STATUS "ELSI CMake package found in ${elsi_DIR}")
    else()
        find_package(PkgConfig)
        if(PkgConfig_FOUND)
            unset(elsi_FOUND CACHE)
            pkg_search_module(elsi elsi)
            if(elsi_FOUND)
                message(STATUS "ELSI pkg-config package found, version ${elsi_VERSION}")
                add_library(elsi::elsi INTERFACE IMPORTED)
                target_link_libraries(elsi::elsi INTERFACE "${elsi_LINK_LIBRARIES}")
                target_include_directories(elsi::elsi INTERFACE "${elsi_INCLUDE_DIRS}")
            endif()
        endif()
    endif()
    if(NOT elsi_FOUND)
        message(SEND_ERROR "ELSI Cmake or pkg-config package not found")
    endif()
endif()

add_subdirectory(src)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== Makefile ===
ifndef VIRTUAL_ENV
$(error Must be run inside a Python virtual environment)
endif

BLDDIR ?= $(CURDIR)/build
export LIBMBD_PREFIX = $(VIRTUAL_ENV)
ifdef MPI_NODES
override RUN_CMD := env OMP_NUM_THREADS=1 mpiexec $(MPIEXEC_EXTRA_FLAGS) -n $(MPI_NODES) $(RUN_CMD)
endif
PYMBD_EXTRAS = test
ifneq (,$(findstring ENABLE_SCALAPACK_MPI=ON,$(CMAKE_ARGS)))
PYMBD_EXTRAS += mpi
endif
EMPTY =
SPACE = $(EMPTY) $(EMPTY)
COMMA = ,

all: install_editable test

run_cmake:
	cmake -B $(BLDDIR) -DCMAKE_INSTALL_PREFIX=$(LIBMBD_PREFIX) $(CMAKE_ARGS)

build_libmbd: run_cmake
	make -C $(BLDDIR) all

install_libmbd: build_libmbd
	make -C $(BLDDIR) install

install_editable: install_libmbd
	pip install -e .[$(subst $(SPACE),$(COMMA),$(PYMBD_EXTRAS))]

install: install_libmbd
	pip install .[$(subst $(SPACE),$(COMMA),$(PYMBD_EXTRAS))]

test_libmbd:
	ctest --test-dir $(BLDDIR) --output-on-failure

test: test_libmbd
	$(RUN_CMD) pytest -v --durations=3

build_doc:
	pip install "Markdown<3.4" "sphinx<3" "Jinja2<3.1" toml git+https://github.com/libmbd/ford@7b44574da7ec20f4ab4b1842ec7561de2a601930
	ford -I. doc/libmbd.md -o build
	sphinx-build -W -d $(BLDDIR)/doctrees doc doc/build/pymbd
	touch doc/build/.nojekyll

distclean:
	-rm -r $(BLDDIR)/*
	-rm src/pymbd/_libmbd.*.so

=== src/CMakeLists.txt ===
configure_file(mbd_version.f90.in "${CMAKE_CURRENT_BINARY_DIR}/mbd_version.f90")

add_library(mbd
    mbd.F90
    mbd_constants.f90
    mbd_coulomb.f90
    mbd_damping.F90
    mbd_density.f90
    mbd_defaults.f90
    mbd_dipole.F90
    mbd_formulas.f90
    mbd_geom.F90
    mbd_gradients.f90
    mbd_hamiltonian.F90
    mbd_lapack.f90
    mbd_linalg.F90
    mbd_matrix.F90
    mbd_methods.F90
    mbd_rpa.F90
    mbd_scs.f90
    mbd_ts.F90
    mbd_utils.F90
    "${CMAKE_CURRENT_BINARY_DIR}/mbd_version.f90"
    mbd_vdw_param.f90
)

if(ENABLE_SCALAPACK_MPI)
    target_sources(mbd PRIVATE mbd_mpi.F90 mbd_blacs.f90 mbd_scalapack.f90)
    if(NOT MPI_Fortran_HAVE_F08_MODULE)
        if("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "NAG")
            set(mismatch_flag "-mismatch")
        elseif("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU"
                AND "${CMAKE_Fortran_COMPILER_VERSION}" VERSION_GREATER_EQUAL "10")
            set(mismatch_flag "-fallow-argument-mismatch -Wno-pedantic")
        endif()
        if(DEFINED mismatch_flag)
            set_source_files_properties(
                SOURCE mbd_geom.F90 mbd_methods.F90 mbd_mpi.F90 mbd_ts.F90
                PROPERTY COMPILE_FLAGS ${mismatch_flag}
            )
        endif()
    endif()
endif()

if(ENABLE_ELSI)
    target_sources(mbd PRIVATE mbd_elsi.F90)
endif()

if(ENABLE_C_API)
    target_sources(mbd PRIVATE mbd_c_api.F90)
endif()

set(moduledir "${CMAKE_CURRENT_BINARY_DIR}/modules")
set(includedir "${CMAKE_INSTALL_INCLUDEDIR}/mbd")
set_target_properties(mbd PROPERTIES Fortran_MODULE_DIRECTORY "${moduledir}")

target_include_directories(mbd
    PRIVATE
        ${moduledir}
    INTERFACE
        $<BUILD_INTERFACE:${moduledir}>
        $<INSTALL_INTERFACE:${includedir}>
)

if(ENABLE_SCALAPACK_MPI)
    target_link_libraries(mbd PRIVATE MPI::MPI_Fortran scalapack)
    set_property(TARGET mbd APPEND PROPERTY COMPILE_DEFINITIONS WITH_MPI WITH_SCALAPACK)
    if(MPI_Fortran_HAVE_F08_MODULE)
        set_property(TARGET mbd APPEND PROPERTY COMPILE_DEFINITIONS WITH_MPIF08)
    endif()
endif()

target_link_libraries(mbd PRIVATE LAPACK::LAPACK)

if(ENABLE_ELSI)
    target_link_libraries(mbd PRIVATE elsi::elsi)
    set_property(TARGET mbd APPEND PROPERTY COMPILE_DEFINITIONS WITH_ELSI)
endif()

if(ENABLE_C_API)
    set_property(TARGET mbd PROPERTY PUBLIC_HEADER mbd.h)
endif()

add_library(Mbd INTERFACE)
target_link_libraries(Mbd INTERFACE mbd)
if(CMAKE_INSTALL_LIBDIR)
    install(TARGETS mbd Mbd EXPORT MbdConfig
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${includedir}"
    )
    install(DIRECTORY "${moduledir}/" DESTINATION "${includedir}")
    install(EXPORT MbdConfig NAMESPACE Mbd:: DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/mbd")
endif()

=== debian/changelog ===
libmbd (0.12.8-2) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 01:27:05 +0100

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

-include /usr/share/mpi-default-dev/debian_defaults

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- 					\
		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
		-DBUILD_SHARED_LIBS=NO				\
		-DBUILD_TESTING=YES

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s/tarball\/(.*)$/@PACKAGE@-$1.tar.gz/ \
 https://api.github.com/repos/libmbd/@PACKAGE@/releases \
 https://api.github.com/repos/libmbd/@PACKAGE@/tarball/@ANY_VERSION@
